import javax.servlet.*; 
import javax.servlet.http.*; 
import java.io.*; 

public class ShoppingCartServlet extends HttpServlet { 

 public static final String INSERT_ITEM = "insert"; 
 public static final String REMOVE_ITEM = "remove"; 
 public static final String REMOVE_ALL = "removeAll"; 
 public static final String INVALID = "invalid"; 
 public static final String CART = "cart"; 

 protected void doGet(HttpServletRequest req, HttpServletResponse res) 
													throws ServletException, IOException { 
	  HttpSession session = req.getSession(true); 
	  ShopCart cart = (ShopCart) session.getAttribute(CART); 
	  if (cart == null) { 
		   cart = new ShopCart(); 
		   session.setAttribute(CART, cart); 
	  } 
	  updateShoppingCart(req, cart);
	  session.setAttribute(CART, cart); 
 } 

 protected void updateShoppingCart(HttpServletRequest req, ShopCart cart) 
                                   					throws ServletException { 
	  String operation = getOperation(req); 
	  if (INSERT_ITEM.equals(operation)) { 
		   addItemToCart(getItemID(req), cart); 
	  } else if (REMOVE_ITEM.equals(operation)) { 
		   removeItemFromCart(getItemID(req), cart); 	  
	  } else if (REMOVE_ALL.equals(operation)) { 
		   removeAllItemsFromCart(cart);
	  } else { 
		   throw new ServletException("Nepovolen opercia: " + operation); 
  	  } 
 } 

 protected String getOperation(HttpServletRequest req) { 
	  String operation = req.getParameter("operation"); 
	  if (operation == null || "".equals(operation)) { 
		   return INVALID; 
	  } else { 
	  		if (!INSERT_ITEM.equals(operation) && !REMOVE_ITEM.equals(operation) && !REMOVE_ALL.equals(operation)) { 
	  			return INVALID; 
			} 
	  	 return operation; 
  	  } 
 } 

 protected String getItemID(HttpServletRequest req) {
        String itemID = req.getParameter("itemID");
        if (itemID == null || "".equals(itemID)) {
            return INVALID;
        } else {
            return itemID;
        }
 }
 
 protected void addItemToCart(String itemID, ShopCart cart) {
	    Item item = findItem(itemID);
	    cart.addItem(item);
 }

  protected Item findItem(String itemID) {
 	    return new Item(itemID, "Description " + itemID);
 }

 protected void removeItemFromCart(String itemID, ShopCart cart) {
	    cart.removeItem(itemID);
 }
 
 protected void removeAllItemsFromCart(ShopCart cart) {
 		cart.clear();
 }
} 